void main() {
	if (drunkFactor > 0) {
		float tau = 6.28318530717958647692;
		
		vec2 texSize = textureSize(InputTexture, 0);
		
		// offset the pixel location by this amount, a sine wave to create a wobble effect
		vec2 drunkOffset = vec2(drunkFactor * sin(tau * TexCoord.y + timer * 0.05), drunkFactor * sin(tau * TexCoord.x + timer * 0.05));
		// two coords, one adds, one subtracts
		// this creates the dual-image effect
		vec2 firstCoord = TexCoord + drunkOffset;
		vec2 secondCoord = TexCoord - drunkOffset;
		
		// return black if the resulting coord isn't on screen
		vec4 firstColor = (firstCoord.x > 0 && firstCoord.x < 1 && firstCoord.y > 0 && firstCoord.y < 1) ?
			texture(InputTexture, firstCoord) : vec4(0, 0, 0, 0);
		vec4 secondColor = (secondCoord.x > 0 && secondCoord.x < 1 && secondCoord.y > 0 && secondCoord.y < 1) ?
			texture(InputTexture, secondCoord) : vec4(0, 0, 0, 0);
		
		// mix the colors
		FragColor = (firstColor + secondColor) / 2;
	}
	else FragColor = texture(InputTexture, TexCoord);
}